package jiaowuxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type school struct {
	Table
	modify     string `name:"modify info" role:"tech"`
	list       string `name:"list city_name school_name auto" role:"void"`
	authCreate string `name:"authCreate" role:"tech"`
}

func (s school) FindOrCreateByName(m *ice.Message, arg ...string) {
	if msg := m.Cmd(s, s.Select, model.NAME, arg[3], arg[0], arg[1]); msg.Length() == 0 {
		msg := m.Cmd(s, s.Insert, model.NAME, arg[3], arg[0], arg[1])
		arg[2], arg[3] = model.SCHOOL_UID, msg.Result()
	} else {
		arg[2], arg[3] = model.SCHOOL_UID, msg.Append(model.UID)
	}
}
func (s school) Modify(m *ice.Message, arg ...string) {
	s.Update(m, kit.Dict(m.OptionSimple(model.INFO)), m.OptionSimple(model.UID)...)
}
func (s school) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		s.CityList(m)
	} else if len(arg) == 1 {
		msg := s.CityList(m.Spawn(), arg[0])
		s.Select(m, model.CITY_UID, msg.Append(model.UID))
	} else if len(arg) == 2 {
		msg := s.CityList(m.Spawn(), arg[0])
		s.Select(m, model.CITY_UID, msg.Append(model.UID), model.NAME, arg[1])
		if m.Append(model.AUTH_UID) == "" && m.IsTech() {
			m.EchoInfoButton("请申请学校认证", s.AuthCreate)
		}
	}
}
func (s school) AuthCreate(m *ice.Message, arg ...string) {
	msg := m.Cmd("web.team.gonganxitong.city", s.Select, model.UID, m.Option(model.CITY_UID))
	s.Table.AuthCreate(m, 5, msg.Append(model.AUTH_UID), m.OptionSimple(model.UID)...)
}

func init() { ice.TeamCtxCmd(school{}) }
